using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace ListEvents
{
	public class FrmMain : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Panel panel1;
    private System.Windows.Forms.Panel panel2;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.Panel panel3;
    private System.Windows.Forms.TreeView tvEventLogs;
    private System.Windows.Forms.ComboBox cbEventType;
    private System.Windows.Forms.ListView lvEvents;
    private System.Windows.Forms.ColumnHeader chDateTime;
    private System.Windows.Forms.ColumnHeader chMessage;
    private System.Windows.Forms.ColumnHeader chType;
    private System.Windows.Forms.ColumnHeader chSource;
    private System.Windows.Forms.Button btnCreateEventLogEntry;
    private System.Windows.Forms.Button btnRegisterForEvents;
		private System.ComponentModel.Container components = null;
		
		public FrmMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
      this.panel1 = new System.Windows.Forms.Panel();
      this.tvEventLogs = new System.Windows.Forms.TreeView();
      this.panel2 = new System.Windows.Forms.Panel();
      this.cbEventType = new System.Windows.Forms.ComboBox();
      this.label1 = new System.Windows.Forms.Label();
      this.panel3 = new System.Windows.Forms.Panel();
      this.lvEvents = new System.Windows.Forms.ListView();
      this.chDateTime = new System.Windows.Forms.ColumnHeader();
      this.chMessage = new System.Windows.Forms.ColumnHeader();
      this.chType = new System.Windows.Forms.ColumnHeader();
      this.chSource = new System.Windows.Forms.ColumnHeader();
      this.btnCreateEventLogEntry = new System.Windows.Forms.Button();
      this.btnRegisterForEvents = new System.Windows.Forms.Button();
      this.panel1.SuspendLayout();
      this.panel2.SuspendLayout();
      this.panel3.SuspendLayout();
      this.SuspendLayout();
      // 
      // panel1
      // 
      this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
      this.panel1.Controls.Add(this.tvEventLogs);
      this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
      this.panel1.Location = new System.Drawing.Point(0, 0);
      this.panel1.Name = "panel1";
      this.panel1.Size = new System.Drawing.Size(136, 390);
      this.panel1.TabIndex = 0;
      // 
      // tvEventLogs
      // 
      this.tvEventLogs.Dock = System.Windows.Forms.DockStyle.Fill;
      this.tvEventLogs.ImageIndex = -1;
      this.tvEventLogs.Location = new System.Drawing.Point(0, 0);
      this.tvEventLogs.Name = "tvEventLogs";
      this.tvEventLogs.SelectedImageIndex = -1;
      this.tvEventLogs.Size = new System.Drawing.Size(132, 386);
      this.tvEventLogs.TabIndex = 0;
      this.tvEventLogs.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvEventLogs_AfterSelect);
      // 
      // panel2
      // 
      this.panel2.Controls.Add(this.btnRegisterForEvents);
      this.panel2.Controls.Add(this.btnCreateEventLogEntry);
      this.panel2.Controls.Add(this.cbEventType);
      this.panel2.Controls.Add(this.label1);
      this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
      this.panel2.Location = new System.Drawing.Point(136, 0);
      this.panel2.Name = "panel2";
      this.panel2.Size = new System.Drawing.Size(528, 40);
      this.panel2.TabIndex = 1;
      // 
      // cbEventType
      // 
      this.cbEventType.Items.AddRange(new object[] {
                                                     "Alle",
                                                     "Information",
                                                     "Warnung",
                                                     "Fehler"});
      this.cbEventType.Location = new System.Drawing.Point(75, 10);
      this.cbEventType.Name = "cbEventType";
      this.cbEventType.Size = new System.Drawing.Size(189, 21);
      this.cbEventType.TabIndex = 1;
      this.cbEventType.Text = "Alle";
      this.cbEventType.SelectedIndexChanged += new System.EventHandler(this.cbEventType_SelectedIndexChanged);
      // 
      // label1
      // 
      this.label1.Location = new System.Drawing.Point(8, 13);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(64, 16);
      this.label1.TabIndex = 0;
      this.label1.Text = "Selektion:";
      // 
      // panel3
      // 
      this.panel3.Controls.Add(this.lvEvents);
      this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
      this.panel3.Location = new System.Drawing.Point(136, 40);
      this.panel3.Name = "panel3";
      this.panel3.Size = new System.Drawing.Size(528, 350);
      this.panel3.TabIndex = 2;
      // 
      // lvEvents
      // 
      this.lvEvents.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                               this.chDateTime,
                                                                               this.chMessage,
                                                                               this.chType,
                                                                               this.chSource});
      this.lvEvents.Dock = System.Windows.Forms.DockStyle.Fill;
      this.lvEvents.Location = new System.Drawing.Point(0, 0);
      this.lvEvents.Name = "lvEvents";
      this.lvEvents.Size = new System.Drawing.Size(528, 350);
      this.lvEvents.TabIndex = 0;
      this.lvEvents.View = System.Windows.Forms.View.Details;
      // 
      // chDateTime
      // 
      this.chDateTime.Text = "Datum / Zeit";
      this.chDateTime.Width = 110;
      // 
      // chMessage
      // 
      this.chMessage.Text = "Nachricht";
      this.chMessage.Width = 200;
      // 
      // chType
      // 
      this.chType.Text = "Type";
      this.chType.Width = 75;
      // 
      // chSource
      // 
      this.chSource.Text = "Quelle";
      this.chSource.Width = 120;
      // 
      // btnCreateEventLogEntry
      // 
      this.btnCreateEventLogEntry.Location = new System.Drawing.Point(272, 10);
      this.btnCreateEventLogEntry.Name = "btnCreateEventLogEntry";
      this.btnCreateEventLogEntry.Size = new System.Drawing.Size(112, 23);
      this.btnCreateEventLogEntry.TabIndex = 2;
      this.btnCreateEventLogEntry.Text = "Ereignis generieren";
      this.btnCreateEventLogEntry.Click += new System.EventHandler(this.btnCreateEventLogEntry_Click);
      // 
      // btnRegisterForEvents
      // 
      this.btnRegisterForEvents.Location = new System.Drawing.Point(392, 10);
      this.btnRegisterForEvents.Name = "btnRegisterForEvents";
      this.btnRegisterForEvents.Size = new System.Drawing.Size(112, 23);
      this.btnRegisterForEvents.TabIndex = 3;
      this.btnRegisterForEvents.Text = "Listener reg.";
      this.btnRegisterForEvents.Click += new System.EventHandler(this.btnRegisterForEvents_Click);
      // 
      // FrmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(664, 390);
      this.Controls.Add(this.panel3);
      this.Controls.Add(this.panel2);
      this.Controls.Add(this.panel1);
      this.Name = "FrmMain";
      this.Text = "Ereignisanzeige";
      this.Load += new System.EventHandler(this.Form1_Load);
      this.panel1.ResumeLayout(false);
      this.panel2.ResumeLayout(false);
      this.panel3.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FrmMain());
		}

    private void Form1_Load(object sender, System.EventArgs e)
    {
      InitializeEventLogs();
    }
    private void InitializeEventLogs()
    {
      tvEventLogs.Nodes.Add("Ereignis-Logs");
      
      EventLog[] logs = EventLog.GetEventLogs();
      foreach(EventLog el in logs)
        tvEventLogs.Nodes[0].Nodes.Add(el.Log);     
      
      tvEventLogs.ExpandAll();      
    }

    private void tvEventLogs_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
    {
      UpdateEventListView();
    }

    private void cbEventType_SelectedIndexChanged(object sender, System.EventArgs e)
    {
      UpdateEventListView();
    }
    
    private void UpdateEventListView()
    {
      String logName;
      if((tvEventLogs.SelectedNode != null) && (tvEventLogs.SelectedNode.Parent != null))
      {
        this.Cursor = Cursors.WaitCursor;
        lvEvents.BeginUpdate();
        lvEvents.Items.Clear();
        logName = tvEventLogs.SelectedNode.Text;
        EventLog el = new EventLog(logName);
        EventLogEntryCollection elec = el.Entries;
        foreach(EventLogEntry ele in elec)
        {
          if((cbEventType.SelectedIndex == 0) ||
            ((cbEventType.SelectedIndex == 1) && (ele.EntryType == EventLogEntryType.Information)) ||
            ((cbEventType.SelectedIndex == 2) && (ele.EntryType == EventLogEntryType.Warning)) ||
            ((cbEventType.SelectedIndex == 3) && (ele.EntryType == EventLogEntryType.Error)))
          {   
            ListViewItem lvi = lvEvents.Items.Insert(0, ele.TimeGenerated.ToString());
            lvi.SubItems.Add(ele.Message);
            lvi.SubItems.Add(ele.EntryType.ToString());
            lvi.SubItems.Add(ele.Source);
          }  
        }  
        lvEvents.EndUpdate();
        this.Cursor = Cursors.Default;        
      }
    }

    private void btnCreateEventLogEntry_Click(object sender, System.EventArgs e)
    {
      EventLog el = new EventLog("Application", ".", "ListEvents-App");
      el.WriteEntry("Achtung Ereignis", EventLogEntryType.Information, 1001, 0, new byte[]{10, 11, 12});
      el.Close();
    }
    public static void OnNewEventLogEntry(object source, EntryWrittenEventArgs e)
    {
      MessageBox.Show(e.Entry.Message);
    }

    private void btnRegisterForEvents_Click(object sender, System.EventArgs e)
    {
      // EventListener registrieren
      EventLog el = new EventLog("Application", ".");
      el.EntryWritten += new EntryWrittenEventHandler(OnNewEventLogEntry);
      el.EnableRaisingEvents = true;    
    }
	}
}











