using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace ListFileVersionInfo
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class FrmMain : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button btnSelectFile;
    private System.Windows.Forms.TextBox tbFileVersionInfo;
    private System.Windows.Forms.OpenFileDialog opndlgFile;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FrmMain()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
      this.btnSelectFile = new System.Windows.Forms.Button();
      this.tbFileVersionInfo = new System.Windows.Forms.TextBox();
      this.opndlgFile = new System.Windows.Forms.OpenFileDialog();
      this.SuspendLayout();
      // 
      // btnSelectFile
      // 
      this.btnSelectFile.Dock = System.Windows.Forms.DockStyle.Top;
      this.btnSelectFile.Location = new System.Drawing.Point(0, 0);
      this.btnSelectFile.Name = "btnSelectFile";
      this.btnSelectFile.Size = new System.Drawing.Size(292, 23);
      this.btnSelectFile.TabIndex = 0;
      this.btnSelectFile.Text = "Datei auswhlen";
      this.btnSelectFile.Click += new System.EventHandler(this.btnSelectFile_Click);
      // 
      // tbFileVersionInfo
      // 
      this.tbFileVersionInfo.AcceptsReturn = true;
      this.tbFileVersionInfo.Dock = System.Windows.Forms.DockStyle.Fill;
      this.tbFileVersionInfo.Location = new System.Drawing.Point(0, 23);
      this.tbFileVersionInfo.Multiline = true;
      this.tbFileVersionInfo.Name = "tbFileVersionInfo";
      this.tbFileVersionInfo.Size = new System.Drawing.Size(292, 243);
      this.tbFileVersionInfo.TabIndex = 1;
      this.tbFileVersionInfo.Text = "";
      // 
      // opndlgFile
      // 
      this.opndlgFile.Filter = "Anwendungen und Dll\'s|*.exe;*.dll|Alle Dateien|*.*";
      // 
      // FrmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(292, 266);
      this.Controls.Add(this.tbFileVersionInfo);
      this.Controls.Add(this.btnSelectFile);
      this.Name = "FrmMain";
      this.Text = "Datei-Versionsinfo anzeigen";
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FrmMain());
		}

    private void btnSelectFile_Click(object sender, System.EventArgs e)
    {
      if(opndlgFile.ShowDialog() == DialogResult.OK)
      {
        tbFileVersionInfo.Text = "";
        FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(opndlgFile.FileName);
        tbFileVersionInfo.AppendText("Firma: " + fvi.CompanyName + Environment.NewLine);
        tbFileVersionInfo.AppendText("Beschreibung: " + fvi.FileDescription + Environment.NewLine);
        tbFileVersionInfo.AppendText("Version: " + fvi.FileVersion + Environment.NewLine);
        tbFileVersionInfo.AppendText("Originaler Name: " + fvi.OriginalFilename + Environment.NewLine);
        tbFileVersionInfo.AppendText("ToString(): " + fvi.ToString());        
      }
    }
	}
}
