using System;
using System.Diagnostics;

namespace ListProzesse
{
	class MainApp
	{
		[STAThread]
		static void Main(string[] args)
		{
		  MainApp ma = new MainApp();
		  ma.ListProcesses();
		  
		  Console.ReadLine();
		}
		private void ListProcesses()
		{
		  Process[] pList = Process.GetProcesses();
		  foreach(Process p in pList)
		  {
		    if(p.Id < 10)
		      continue;
		    try
		    {
		      Console.WriteLine(p.ProcessName);
		      Console.WriteLine(p.MainModule.FileName);
		      Console.WriteLine(p.TotalProcessorTime.Minutes.ToString());
		      ProcessModuleCollection pmList = p.Modules;
		      foreach(ProcessModule pm in pmList)
		      {
	          Console.WriteLine("  >" + pm.FileName);	    
		      }
		    }
		    catch(Exception e)
		    {
		      Console.WriteLine("Prozess: " + p.ProcessName + " macht Schwierigkeiten.");
		    }  
		    Console.WriteLine("************************************");
		  }  		    
		}
	}
}
