using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace StartProzesse
{
	public class FrmMain : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button btnStart1;
    private System.Windows.Forms.Button btnStart2;
    private System.Windows.Forms.Button btnKillCalcApp;
		private System.ComponentModel.Container components = null;

		public FrmMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
      this.btnStart1 = new System.Windows.Forms.Button();
      this.btnStart2 = new System.Windows.Forms.Button();
      this.btnKillCalcApp = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // btnStart1
      // 
      this.btnStart1.Location = new System.Drawing.Point(16, 16);
      this.btnStart1.Name = "btnStart1";
      this.btnStart1.Size = new System.Drawing.Size(256, 23);
      this.btnStart1.TabIndex = 0;
      this.btnStart1.Text = "Start ber Verknpfung";
      this.btnStart1.Click += new System.EventHandler(this.btnStart1_Click);
      // 
      // btnStart2
      // 
      this.btnStart2.Location = new System.Drawing.Point(16, 48);
      this.btnStart2.Name = "btnStart2";
      this.btnStart2.Size = new System.Drawing.Size(256, 23);
      this.btnStart2.TabIndex = 1;
      this.btnStart2.Text = "Start ber ProcessStartInfo";
      this.btnStart2.Click += new System.EventHandler(this.btnStart2_Click);
      // 
      // btnKillCalcApp
      // 
      this.btnKillCalcApp.Location = new System.Drawing.Point(16, 80);
      this.btnKillCalcApp.Name = "btnKillCalcApp";
      this.btnKillCalcApp.Size = new System.Drawing.Size(256, 23);
      this.btnKillCalcApp.TabIndex = 2;
      this.btnKillCalcApp.Text = "Taschenrechnerinstanzen beenden";
      this.btnKillCalcApp.Click += new System.EventHandler(this.btnKillCalcApp_Click);
      // 
      // FrmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(292, 118);
      this.Controls.Add(this.btnKillCalcApp);
      this.Controls.Add(this.btnStart2);
      this.Controls.Add(this.btnStart1);
      this.Name = "FrmMain";
      this.Text = "Prozesse starten";
      this.ResumeLayout(false);

    }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FrmMain());
		}

    private void btnStart1_Click(object sender, System.EventArgs e)
    {
      String fileName = "C:\\Textdatei.txt";
      try
      {
        Process.Start(fileName);   
      }
      catch(Exception ex)
      {
        MessageBox.Show("Fehler beim ffnen von " + fileName);
      }       
    }

    private void btnStart2_Click(object sender, System.EventArgs e)
    {
      
      ProcessStartInfo psi = new ProcessStartInfo();
      psi.FileName = "Calc.exe";
      psi.WorkingDirectory = "C:\\Temp";
      psi.WindowStyle = ProcessWindowStyle.Maximized;
      Process p = Process.Start(psi);
      p.WaitForExit();
      MessageBox.Show("ExitCode: " + p.ExitCode);
    }

    private void btnKillCalcApp_Click(object sender, System.EventArgs e)
    {
  		Process[] procToKill = Process.GetProcessesByName("Calc");
      foreach(Process p in procToKill)
        p.Kill();
      // oder  
      // procToKill.CloseMainWindow();
    }
	}
}